#ifndef apache13_defined
#define apache13_defined

/** method of declaring a directive which takes 1 argument */
# define AP_INIT_TAKE1(directive, func, mconfig, where, help) \
    { directive, func, mconfig, where, TAKE1, help }
/** method of declaring a directive which takes a flag (on/off) as an argument */
# define AP_INIT_FLAG(directive, func, mconfig, where, help) \
    { directive, func, mconfig, where, FLAG, help }


/* Types */
#define apr_pool_t pool
#define apr_array_header_t array_header
#define apr_table_t table

#define apr_palloc ap_palloc
#define apr_pcalloc ap_pcalloc
#define apr_pstrdup ap_pstrdup
#define apr_pstrcat ap_pstrcat
#define apr_psprintf ap_psprintf
#define apr_snprintf ap_snprintf

#define APR_OFFSETOF XtOffsetOf
#define AUTH_REQUIRED HTTP_UNAUTHORIZED



#include <multithread.h>
#include <http_conf_globals.h>

/*static void nufw_log_error(char *file, 
                          int line, 
                          int level, 
                          const server_rec *s, 
                          const char *fmt, 
                          ...) 
                          __attribute__ ((format (printf, 5,6)));
*/
static inline void nufw_log_error(char *file, 
                             int line, 
                             int level, 
                             const server_rec *s, 
                             const char *fmt, 
                             ...)
{
  static char buff[MAX_STRING_LEN];
  va_list args;
  va_start(args, fmt);
  ap_vsnprintf(buff,MAX_STRING_LEN, fmt,args);
  ap_log_error(file,line,level | APLOG_NOERRNO ,s,"%s",buff);
  va_end(args);
}

static inline void nufw_log_rerror(char *file, 
                             int line, 
                             int level, 
                             const request_rec *r, 
                             const char *fmt, 
                             ...)
{
  static char buff[MAX_STRING_LEN];
  va_list args;
  va_start(args, fmt);
  ap_vsnprintf(buff,MAX_STRING_LEN, fmt,args);
  ap_log_rerror(file,line,level | APLOG_NOERRNO ,r,"%s",buff);
  va_end(args);
}

#endif //apache13_defined
