/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 * of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/


#include "nufw_declarations.h"

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>


#define NUFW_CONNECTDB_NULL_POINTER -1
#define NUFW_CONNECTDB_ERROR -2
#define NUFW_CONNECTDB_OK 0

#ifdef DB_TYPE_MYSQL
const char *nufw_sql_connectdb(MYSQL **sql,
                         char *host,
                         char *user,
                         char *database,
                         unsigned int port,
                         char *pass,
                         int ssl_enabled,
                         char *ssl_key,
                         char *ssl_cert,
                         char *ssl_ca,
                         char *ssl_ca_dir,
                         char *ssl_cypher);
long int nufw_sql_find_entry(struct apr_pool_t *ourpool,
                             unsigned short int protocol,
                             char *table,
                             struct in_addr addr,
                             unsigned short int sin_port,
                             struct in_addr local_addr,
                             unsigned short int local_sin_port,
                             struct timeval *tv,
                             unsigned short int window,
                             char **user,
                             MYSQL *conn);
int nufw_closedb(MYSQL *sql);
int nufw_sql_ping(MYSQL *sql);
#else
char *nufw_sql_connectdb(PGconn **sql,
                         char *host,
                         char *user,
                         char *database,
                         unsigned int port,
                         char *pass,
                         int ssl_enabled,
                         char *ssl_key,
                         char *ssl_cert,
                         char *ssl_ca,
                         char *ssl_ca_dir,
                         char *ssl_cypher);
long int nufw_sql_find_entry(struct apr_pool_t *ourpool,
                             unsigned short int protocol,
                             char *table,
                             struct in_addr addr,
                             unsigned short int sin_port,
                             struct in_addr local_addr,
                             unsigned short int local_sin_port,
                             struct timeval *tv,
                             unsigned short int window,
                             char **user,
                             PGconn *conn);
int nufw_closedb(PGconn *sql);
int nufw_sql_ping(PGconn *sql);
#endif
__time_t time_calculate(struct timeval *tv, unsigned short int window, int plusmoins);
unsigned int nufw_sql_thread_safe(void);
