/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

/* Default time window : 10 tenth of second */
#ifdef APACHE20
#define APACHE2X 1
#endif
#ifdef APACHE22
#define APACHE2X 1
#endif

#define DEFAULT_TIME_WINDOW 0

#define DEFAULT_NUFW_PROTOCOL_VERSION 2

#define DEFAULT_SQL_SSL_KEY "/usr/local/apache/conf/nufw_sql_ssl_private.key"
#define DEFAULT_SQL_SSL_CERT "/usr/local/apache/conf/nufw_sql_ssl_public.cert"
#define DEFAULT_SQL_SSL_CYPHER "ALL:!ADH:+RC4:@STRENGTH"

/* SQL Backend. If this is unset, we use postgresql.*/
//#define DB_TYPE_MYSQL 1

/* Maximum number of simultaneous SQL Connections at any time*/
#define DEFAULT_MAX_CONCURRENT_SQL_CONNECTIONS 8
#define DEFAULT_MAX_SIMILAR_SQL_CONNECTIONS 4

#ifdef AP_HAVE_DESIGNATED_INITIALIZER
#undef AP_HAVE_DESIGNATED_INITIALIZER
#endif

#ifdef _GNU_SOURCE
#undef _GNU_SOURCE
#endif

#define _GNU_SOURCE
#include <string.h>

#include <unistd.h>

#include <httpd.h>
#include <http_config.h>
#include <http_core.h>
#include <http_log.h>
#include <http_main.h>
#include <http_protocol.h>
#include <http_request.h>

#ifdef DB_TYPE_MYSQL
#include <mysql/mysql.h>
#else
#include <postgresql/libpq-fe.h>
#endif

#ifdef APACHE2X
#include "apache20.h"
#else
#include "apache13.h"
#endif


#define SQL_CANT_CONVERT_ADDR -1
#define SQL_MINTIME_CALCULATE_ERROR -2
#define SQL_MAXTIME_CALCULATE_ERROR -3
#define SQL_CANT_BUILD_REQUEST -4
#define SQL_QUERY_ERROR -5
#define SQL_RESULT_ERROR -6
#define SQL_NO_MATCH -7
#define SQL_TOO_MANY_MATCHES -8
#define SQL_UNKNOWN_PROTOCOL -9
#define SQL_INSUFFICIENT_MEM -10

#define SQL_BAD_HOST -1
#define SQL_BAD_USER -2
#define SQL_BAD_PORT -3
#define SQL_BAD_DATABASE -4
#define SQL_BAD_PASS -5
#define SQL_BAD_SSL_KEY -6
#define SQL_BAD_SSL_CERT -7
#define SQL_BAD_SSL_CYPHER -8
#define SQL_UNREADABLE_CA -9
#define SQL_UNREADABLE_CA_DIR -10
#define SQL_UNREADABLE_SSL_KEY -11
#define SQL_UNREADABLE_SSL_CERT -12
